hdu 1690(Floyed)

Bus System

Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 32768/32768 K (Java/Others)
Total Submission(s): 8055    Accepted Submission(s): 2121

Problem Description

Because
of the huge population of China, public transportation is very
important. Bus is an important transportation method in traditional
public transportation system. And it’s still playing an important role
even now.
The bus system of City X is quite strange. Unlike other
city’s system, the cost of ticket is calculated based on the distance
between the two stations. Here is a list which describes the
relationship between the distance and the cost.

Your
neighbor is a person who is a really miser. He asked you to help him to
calculate the minimum cost between the two stations he listed. Can you
solve this problem for him?
To simplify this problem, you can assume
that all the stations are located on a straight line. We use
x-coordinates to describe the stations’ positions.

Input

The
input consists of several test cases. There is a single number above
all, the number of cases. There are no more than 20 cases.
Each case
contains eight integers on the first line, which are L1, L2, L3, L4, C1,
C2, C3, C4, each number is non-negative and not larger than
1,000,000,000. You can also assume that L1<=L2<=L3<=L4.
Two
integers, n and m, are given next, representing the number of the
stations and questions. Each of the next n lines contains one integer,
representing the x-coordinate of the ith station. Each of the next m
lines contains two integers, representing the start point and the
destination.
In all of the questions, the start point will be different from the destination.
For
each case,2<=N<=100,0<=M<=500, each x-coordinate is between
-1,000,000,000 and 1,000,000,000, and no two x-coordinates will have
the same value.

Output

For
each question, if the two stations are attainable, print the minimum
cost between them. Otherwise, print “Station X and station Y are not
attainable.” Use the format in the sample.

Sample Input

2
1 2 3 4 1 3 5 7
4 2
1
2
3
4
1 4
4 1
1 2 3 4 1 3 5 7
4 1
1
2
3
10
1 4

Sample Output

Case 1:
The minimum cost between station 1 and station 4 is 3.
The minimum cost between station 4 and station 1 is 3.
Case 2:
Station 1 and station 4 are not attainable.

注意这题INF要很大。。我就是因为INF开小了一点点就WA了。

#include <stdio.h>
#include <algorithm>
#include <string.h>
#include <iostream>
#include <stdlib.h>
using namespace std;
typedef long long ll;
const ll INF =111111111111;
const int N = 105;
ll graph[N][N];
ll L[4],C[4];
ll x[N];
ll check(ll dis){
    if(dis<=L[0]) return C[0];
    else if(dis>L[0]&&dis<=L[1]) return C[1];
    else if(dis>L[1]&&dis<=L[2]) return C[2];
    else if(dis>L[2]&&dis<=L[3]) return C[3];
    return INF;
}
int main()
{
    int tcase;
    scanf("%d",&tcase);
    int t = 1;
    while(tcase--){
        for(int i=0;i<4;i++){
            scanf("%lld",&L[i]);
        }
        sort(L,L+4);
        for(int i=0;i<4;i++){
            scanf("%lld",&C[i]);
        }
        int n,m;
        scanf("%d%d",&n,&m);
        for(int i=0;i<n;i++){
            scanf("%lld",&x[i]);
        }
        for(int i=0;i<n;i++){
            for(int j=0;j<n;j++){
                if(i==j) graph[i][j] = 0;
                else{
                    ll dis = abs(x[i]-x[j]);
                    graph[i][j]=check(dis);
                }
            }
        }
        for(int k=0;k<n;k++){
            for(int i=0;i<n;i++){
                if(graph[k][i]<INF){
                    for(int j=0;j<n;j++){
                        graph[i][j] = min(graph[i][j],graph[i][k]+graph[k][j]);
                    }
                }
            }
        }
        printf("Case %d:\n",t++);
        while(m--){
            int a,b;
            scanf("%d%d",&a,&b);
            int c = a-1,d=b-1;
            if(graph[c][d]>=INF) printf("Station %d and station %d are not attainable.\n",a,b);
            else printf("The minimum cost between station %d and station %d is %lld.\n",a,b,graph[c][d]);
        }
    }
}
时间: 2024-11-05 22:35:49

hdu 1690(Floyed)的相关文章

hdu 1690 Bus System (最短路径)

Bus System Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 32768/32768 K (Java/Others)Total Submission(s): 6082    Accepted Submission(s): 1560 Problem Description Because of the huge population of China, public transportation is very importa

hdu 1690 Bus System(Floyd)

题目链接:http://acm.hdu.edu.cn/showproblem.php?pid=1690 Problem Description Because of the huge population of China, public transportation is very important. Bus is an important transportation method in traditional public transportation system. And it's

hdu 1690 Bus System(Dijkstra最短路)

题目链接:http://acm.hdu.edu.cn/showproblem.php?pid=1690 Bus System Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 32768/32768 K (Java/Others)Total Submission(s): 6569    Accepted Submission(s): 1692 Problem Description Because of the huge popula

hdu 1690

#include <stdio.h> #include <string.h> #include <algorithm> using namespace std; #define N 1005 #define INF 200000000000 #define LL __int64 LL ma[N][N],d[N],vis[N],dis[N]; LL dijkstral(LL v0,LL n,LL t) { LL v,x,y,temp,i; for(i = 1 ; i &l

hdu 1690 Bus System(最短路)

问题: 链接:点击打开链接 题意: 思路: 代码: #include <iostream> #include <cstdio> #include <cstring> using namespace std; #define INF 1000000000000 typedef __int64 LL; const int N = 110; __int64 dis[N][N],place[N]; __int64 L1,L2,L3,L4,C1,C2,C3,C4; int n,m

HDU 1690 Bus System 任意点最短路径Floyd

原题: http://acm.hdu.edu.cn/showproblem.php?pid=1690 题目大意: 图中的表是代表不同长度路径的花费,输入所有点的坐标,求任意两点间的最短花费. 因为是求任意两点,这里最好是用floyd算法. 题中几大坑: 数据可能会超int,要用long long int: 坐标可以为负,求距离要用abs绝对值函数. 参考代码如下: #include <iostream> #include"iostream" #include"st

hdu 1181(Floyed)

变形课 Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 131072/65536 K (Java/Others)Total Submission(s): 20748    Accepted Submission(s): 7494 Problem Description 呃......变形课上Harry碰到了一点小麻烦,因为他并不像Hermione那样能够记住所有的咒语而随意的将一个棒球变成刺猬什么的,但是他发现了变形咒语的一个统一规

hdu 1690 构图后Floyd 数据很大

WA了好多次... 这题要用long long 而且INF要设大一点 Sample Input2 //T1 2 3 4 1 3 5 7 //L1-L4 C1-C4 距离和花费4 2 //结点数 询问次数1 //结点的横坐标2341 4 //起点 终点4 11 2 3 4 1 3 5 74 1123101 4 Sample OutputCase 1:The minimum cost between station 1 and station 4 is 3.The minimum cost betw

hdu 1690 Bus System 最短路 Floyd算法。。INF一定要很大很大。。。数据类型用long long。

Bus System Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 32768/32768 K (Java/Others) Total Submission(s): 7163    Accepted Submission(s): 1853 Problem Description Because of the huge population of China, public transportation is very import